import {Letter} from './Letter';

export interface FrequencyLetters {
	[key: string]: number;
}
export interface FrequencyLang {
	[key: string]: FrequencyLetters;
}
export class Frequency {


	get frequency(): FrequencyLetters {
		return this._frequency;
	}

	constructor(frequency: FrequencyLetters) {
		this._frequency = frequency;
	}
	public static readonly frequencyByLanguage: FrequencyLang = {english: {a: 0.08166999999999999, b: 0.01492, c: 0.02782, d: 0.04253, e: 0.12702, f: 0.02228, g: 0.02015, h: 0.06094, i: 0.06966, j: 0.00153, k: 0.00772, l: 0.04025, m: 0.02406, n: 0.06749, o: 0.07507, p: 0.01929, q: 0.00095, r: 0.05987, s: 0.06326999999999999, t: 0.09055999999999999, u: 0.02758, v: 0.00978, w: 0.0236, x: 0.0015, y: 0.01974, z: 0.00074, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, french: {a: 0.07636, b: 0.00901, c: 0.0326, d: 0.03669, e: 0.14715, f: 0.010660000000000001, g: 0.00866, h: 0.00737, i: 0.07529, j: 0.00613, k: 0.00074, l: 0.054560000000000004, m: 0.029679999999999998, n: 0.07095, o: 0.057960000000000005, p: 0.02521, q: 0.01362, r: 0.06692999999999999, s: 0.07948000000000001, t: 0.07244, u: 0.06311, v: 0.01838, w: 0.00049, x: 0.0042699999999999995, y: 0.00128, z: 0.0032600000000000003, à: 0.00486, â: 0.0005099999999999999, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0.00017999999999999998, ç: 0.0008500000000000001, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0.00271, é: 0.01504, ê: 0.00218, ë: 0.00008, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0.00045, ì: 0, í: 0, ï: 0.00005, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0.00023, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0.00058, ú: 0, û: 0.0006, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, german: {a: 0.06516, b: 0.01886, c: 0.02732, d: 0.05076, e: 0.16396, f: 0.01656, g: 0.03009, h: 0.04577, i: 0.0655, j: 0.00268, k: 0.01417, l: 0.03437, m: 0.025339999999999998, n: 0.09776, o: 0.025939999999999998, p: 0.0067, q: 0.00017999999999999998, r: 0.07003, s: 0.0727, t: 0.06154, u: 0.04166, v: 0.00846, w: 0.01921, x: 0.00034, y: 0.00039, z: 0.01134, à: 0, â: 0, á: 0, å: 0, ä: 0.0057799999999999995, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0.00443, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0.00307, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0.00995, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, spanish: {a: 0.11525, b: 0.02215, c: 0.040190000000000003, d: 0.0501, e: 0.12180999999999999, f: 0.006919999999999999, g: 0.01768, h: 0.00703, i: 0.06247, j: 0.00493, k: 0.00010999999999999999, l: 0.04967, m: 0.03157, n: 0.06712, o: 0.08683, p: 0.025099999999999997, q: 0.00877, r: 0.06871000000000001, s: 0.07977000000000001, t: 0.04632, u: 0.02927, v: 0.01138, w: 0.00017, x: 0.00215, y: 0.01008, z: 0.0046700000000000005, à: 0, â: 0, á: 0.00502, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0.00433, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0.0072499999999999995, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0.00311, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0.00827, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0.00168, û: 0, ŭ: 0, ü: 0.00012, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, portuguese: {a: 0.14634, b: 0.01043, c: 0.03882, d: 0.04992, e: 0.1257, f: 0.01023, g: 0.01303, h: 0.00781, i: 0.06186, j: 0.0039700000000000004, k: 0.00015, l: 0.02779, m: 0.047380000000000005, n: 0.04446, o: 0.09734999999999999, p: 0.025230000000000002, q: 0.01204, r: 0.0653, s: 0.06805, t: 0.04336, u: 0.03639, v: 0.01575, w: 0.00037, x: 0.00253, y: 0.00006, z: 0.004699999999999999, à: 0.0007199999999999999, â: 0.005620000000000001, á: 0.0011799999999999998, å: 0, ä: 0, ã: 0.00733, ą: 0, æ: 0, œ: 0, ç: 0.0053, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0.00337, ê: 0.0045000000000000005, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0.00132, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0.00635, ó: 0.00296, õ: 0.0004, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0.00207, û: 0, ŭ: 0, ü: 0.00026, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, esperanto: {a: 0.12117000000000001, b: 0.0098, c: 0.00776, d: 0.030440000000000002, e: 0.08994999999999999, f: 0.010369999999999999, g: 0.01171, h: 0.00384, i: 0.10012, j: 0.03501, k: 0.04163, l: 0.061040000000000004, m: 0.02994, n: 0.07955, o: 0.08778999999999999, p: 0.027549999999999998, q: 0, r: 0.05914, s: 0.060919999999999995, t: 0.05276, u: 0.03183, v: 0.019039999999999998, w: 0, x: 0, y: 0, z: 0.00494, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0.00657, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0.0069099999999999995, ğ: 0, ĥ: 0.00021999999999999998, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0.00055, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0.00385, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0.0052, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, italian: {a: 0.11745, b: 0.00927, c: 0.04501, d: 0.037360000000000004, e: 0.11792, f: 0.01153, g: 0.01644, h: 0.00636, i: 0.10143, j: 0.00010999999999999999, k: 0.00008999999999999999, l: 0.06509999999999999, m: 0.02512, n: 0.06883, o: 0.09832, p: 0.03056, q: 0.00505, r: 0.06367, s: 0.04981, t: 0.05623, u: 0.03011, v: 0.02097, w: 0.00033, x: 0.00003, y: 0.0002, z: 0.011810000000000001, à: 0.00635, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0.00263, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0.0003, í: 0.0003, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0.00002, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0.00166, ú: 0.00166, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, turkish: {a: 0.1192, b: 0.02844, c: 0.00963, d: 0.047060000000000005, e: 0.08912, f: 0.00461, g: 0.01253, h: 0.012119999999999999, i: 0.086, j: 0.00034, k: 0.04683, l: 0.059219999999999995, m: 0.03752, n: 0.07487, o: 0.02476, p: 0.00886, q: 0, r: 0.06722, s: 0.030139999999999997, t: 0.03314, u: 0.03235, v: 0.00959, w: 0, x: 0, y: 0.03336, z: 0.015, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0.011559999999999999, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0.01125, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0.05114, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0.00777, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0.0178, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0.01854, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, swedish: {a: 0.09383, b: 0.015349999999999999, c: 0.01486, d: 0.04702, e: 0.10149, f: 0.02027, g: 0.02862, h: 0.0209, i: 0.05817, j: 0.00614, k: 0.031400000000000004, l: 0.052750000000000005, m: 0.03471, n: 0.08542, o: 0.04482, p: 0.01839, q: 0.0002, r: 0.08431, s: 0.0659, t: 0.07690999999999999, u: 0.01919, v: 0.02415, w: 0.0014199999999999998, x: 0.00159, y: 0.0070799999999999995, z: 0.0007000000000000001, à: 0, â: 0, á: 0, å: 0.013380000000000001, ä: 0.01797, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0.013049999999999999, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, polish: {a: 0.10503, b: 0.0174, c: 0.03895, d: 0.03725, e: 0.07352, f: 0.0014299999999999998, g: 0.017310000000000002, h: 0.01015, i: 0.08327999999999999, j: 0.01836, k: 0.027530000000000002, l: 0.02564, m: 0.025150000000000002, n: 0.06237, o: 0.06667, p: 0.02445, q: 0, r: 0.052430000000000004, s: 0.05224, t: 0.02475, u: 0.02062, v: 0.00012, w: 0.058129999999999994, x: 0.00004, y: 0.03206, z: 0.04852, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0.00699, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0.00743, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0.01035, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0.02109, ñ: 0, ń: 0.00362, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0.01141, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0.00814, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0.00078, ż: 0.0070599999999999994, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, dutch: {a: 0.07486, b: 0.01584, c: 0.01242, d: 0.05933, e: 0.1891, f: 0.00805, g: 0.03403, h: 0.023799999999999998, i: 0.06498999999999999, j: 0.0146, k: 0.022480000000000003, l: 0.03568, m: 0.02213, n: 0.10032, o: 0.060629999999999996, p: 0.015700000000000002, q: 0.00008999999999999999, r: 0.06411, s: 0.0373, t: 0.0679, u: 0.0199, v: 0.0285, w: 0.0152, x: 0.00035999999999999997, y: 0.00035000000000000005, z: 0.0139, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, danish: {a: 0.060250000000000005, b: 0.02, c: 0.00565, d: 0.05857999999999999, e: 0.15453, f: 0.02406, g: 0.04077, h: 0.01621, i: 0.06, j: 0.0073, k: 0.03395, l: 0.05229, m: 0.03237, n: 0.0724, o: 0.04636, p: 0.01756, q: 0.00007000000000000001, r: 0.08956, s: 0.05805, t: 0.06862, u: 0.019790000000000002, v: 0.023319999999999997, w: 0.0006900000000000001, x: 0.00028000000000000003, y: 0.006979999999999999, z: 0.00034, à: 0, â: 0, á: 0, å: 0.011899999999999999, ä: 0, ã: 0, ą: 0, æ: 0.00872, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0.009389999999999999, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, icelandic: {a: 0.1011, b: 0.01043, c: 0, d: 0.01575, e: 0.06418, f: 0.03013, g: 0.042409999999999996, h: 0.01871, i: 0.07578, j: 0.011439999999999999, k: 0.03314, l: 0.04532, m: 0.04041, n: 0.07711, o: 0.02166, p: 0.007890000000000001, q: 0, r: 0.08581, s: 0.056299999999999996, t: 0.049530000000000005, u: 0.04562, v: 0.02437, w: 0, x: 0.00046, y: 0.009000000000000001, z: 0, à: 0, â: 0, á: 0.01799, å: 0, ä: 0, ã: 0, ą: 0, æ: 0.00867, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0.04393, è: 0, é: 0.00647, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0.015700000000000002, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0.00777, ô: 0, ó: 0.00994, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0.01455, ù: 0, ú: 0.00613, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0.00228, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, finnish: {a: 0.12217, b: 0.0028100000000000004, c: 0.0028100000000000004, d: 0.01043, e: 0.07968, f: 0.00194, g: 0.00392, h: 0.01851, i: 0.10817, j: 0.020419999999999997, k: 0.049729999999999996, l: 0.05761, m: 0.03202, n: 0.08826, o: 0.056139999999999995, p: 0.018420000000000002, q: 0.00013, r: 0.02872, s: 0.07862, t: 0.0875, u: 0.05008, v: 0.0225, w: 0.00094, x: 0.00031, y: 0.01745, z: 0.0005099999999999999, à: 0, â: 0, á: 0, å: 0.00003, ä: 0.035769999999999996, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0.00444, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, czech: {a: 0.08421, b: 0.00822, c: 0.0074, d: 0.03475, e: 0.07562, f: 0.00084, g: 0.00092, h: 0.013560000000000001, i: 0.060730000000000006, j: 0.01433, k: 0.02894, l: 0.03802, m: 0.024460000000000003, n: 0.06468, o: 0.06695000000000001, p: 0.01906, q: 0.00001, r: 0.047990000000000005, s: 0.05212, t: 0.05727, u: 0.0216, v: 0.05344, w: 0.00016, x: 0.00027, y: 0.01043, z: 0.015029999999999998, à: 0, â: 0, á: 0.00867, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0.00462, ď: 0.00015, ð: 0, è: 0, é: 0.00633, ê: 0, ë: 0, ę: 0, ě: 0.01222, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0.01643, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0.00007000000000000001, ò: 0, ö: 0, ô: 0, ó: 0.00024, õ: 0, ø: 0, ř: 0.0038, ŝ: 0, ş: 0, ś: 0, š: 0.00688, ß: 0, ť: 0.00006, þ: 0, ù: 0, ú: 0.00045, û: 0, ŭ: 0, ü: 0, ů: 0.0020399999999999997, ý: 0.00995, ź: 0, ż: 0, ž: 0.007209999999999999, о: 0, е: 0, а: 0, и: 0, н: 0, т: 0, с: 0, р: 0, в: 0, л: 0, к: 0, м: 0, д: 0, п: 0, у: 0, я: 0, ы: 0, ь: 0, г: 0, з: 0, б: 0, ч: 0, й: 0, х: 0, ж: 0, ш: 0, ю: 0, ц: 0, щ: 0, э: 0, ф: 0, ъ: 0, ё: 0}, russian: {a: 0, b: 0, c: 0, d: 0, e: 0, f: 0, g: 0, h: 0, i: 0, j: 0, k: 0, l: 0, m: 0, n: 0, o: 0, p: 0, q: 0, r: 0, s: 0, t: 0, u: 0, v: 0, w: 0, x: 0, y: 0, z: 0, à: 0, â: 0, á: 0, å: 0, ä: 0, ã: 0, ą: 0, æ: 0, œ: 0, ç: 0, ĉ: 0, ć: 0, č: 0, ď: 0, ð: 0, è: 0, é: 0, ê: 0, ë: 0, ę: 0, ě: 0, ĝ: 0, ğ: 0, ĥ: 0, î: 0, ì: 0, í: 0, ï: 0, ı: 0, ĵ: 0, ł: 0, ñ: 0, ń: 0, ň: 0, ò: 0, ö: 0, ô: 0, ó: 0, õ: 0, ø: 0, ř: 0, ŝ: 0, ş: 0, ś: 0, š: 0, ß: 0, ť: 0, þ: 0, ù: 0, ú: 0, û: 0, ŭ: 0, ü: 0, ů: 0, ý: 0, ź: 0, ż: 0, ž: 0, о: 0.1097, е: 0.08449999999999999, а: 0.0801, и: 0.0735, н: 0.067, т: 0.0626, с: 0.0547, р: 0.0473, в: 0.0454, л: 0.044000000000000004, к: 0.0349, м: 0.0321, д: 0.0298, п: 0.0281, у: 0.0262, я: 0.020099999999999996, ы: 0.019, ь: 0.0174, г: 0.017, з: 0.0165, б: 0.0159, ч: 0.0144, й: 0.0121, х: 0.0097, ж: 0.009399999999999999, ш: 0.0073, ю: 0.0064, ц: 0.0048, щ: 0.0036, э: 0.0032, ф: 0.0026, ъ: 0.0004, ё: 0.0004}};
	private readonly _frequency: FrequencyLetters;
	public static create(str: string): Frequency {
		str = str.replace(/[\s]+/g, '');
		const s = 1 / str.length;
		const array: FrequencyLetters = {};
		for (let i = 0; i < str.length; i++) {
			if (!array.hasOwnProperty(str.charAt(i))) { array[str.charAt(i)] = 0; }
			array[str.charAt(i)] += s;
		}
		return new Frequency(array).sort();
	}



	public max(): Letter {
		const freq = this.sort();
		let temp = new Letter('', -1);
		for (const key in freq._frequency) {
			if (freq._frequency[key] > temp.frequency) {
				temp = new Letter(key, freq._frequency[key]);
			}
		}
		return temp;
	}

	public sort(): Frequency {
		let array = this._frequency;
		const arr = [];
		for (const key in array) {
		  if (array.hasOwnProperty(key)) {
			  arr.push({key, value: array[key]});
      }
		}
		arr.sort((a, b) => {
			return a.value > b.value ? 1 : a.value < b.value ? -1 : 0;
		});
		array = {};
		arr.forEach((value => array[value.key] = value.value));
		return new Frequency(array);
	}
}
